package com.idiot.operationbackend.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import org.springframework.beans.factory.annotation.Autowired;

import javax.validation.constraints.NotEmpty;
import java.util.List;

/**
 * 二维码内容
 * @author wang xiao
 * @date Created in 18:05 2020/9/21
 */
@TableName("t_qr_code")
public class QrCode {

    @TableId
    private String  id;

    private String nikeName;

    private String headImg;

    @NotEmpty(message = "请选择公众号")
    private String accountId;

    @NotEmpty(message = "请填写二维码名称")
    private String label;

    @NotEmpty(message = "请选择生成类型")
    private Integer type;

    private Long  totalNum;

    private Long newNum;

    private Long followNum;

    private String url;

    private String ticket;

    private Integer pushType;

    private String materialIds;

    private String articlesIds;

    private String createTime;

    private String expireTime;

    @TableField(exist = false)
    private List<Object> contents;


    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getAccountId() {
        return accountId;
    }

    public void setAccountId(String accountId) {
        this.accountId = accountId;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    public Long getTotalNum() {
        return totalNum;
    }

    public void setTotalNum(Long totalNum) {
        this.totalNum = totalNum;
    }

    public Long getNewNum() {
        return newNum;
    }

    public void setNewNum(Long newNum) {
        this.newNum = newNum;
    }

    public Long getFollowNum() {
        return followNum;
    }

    public void setFollowNum(Long followNum) {
        this.followNum = followNum;
    }

    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public Integer getPushType() {
        return pushType;
    }

    public void setPushType(Integer pushType) {
        this.pushType = pushType;
    }

    public String getMaterialIds() {
        return materialIds;
    }

    public void setMaterialIds(String materialIds) {
        this.materialIds = materialIds;
    }

    public String getArticlesIds() {
        return articlesIds;
    }

    public void setArticlesIds(String articlesIds) {
        this.articlesIds = articlesIds;
    }

    public List<Object> getContents() {
        return contents;
    }

    public void setContents(List<Object> contents) {
        this.contents = contents;
    }

    public String getCreateTime() {
        return createTime;
    }

    public void setCreateTime(String createTime) {
        this.createTime = createTime;
    }

    public String getExpireTime() {
        return expireTime;
    }

    public void setExpireTime(String expireTime) {
        this.expireTime = expireTime;
    }

    public String getNikeName() {
        return nikeName;
    }

    public void setNikeName(String nikeName) {
        this.nikeName = nikeName;
    }

    public String getHeadImg() {
        return headImg;
    }

    public void setHeadImg(String headImg) {
        this.headImg = headImg;
    }

    public String getTicket() {
        return ticket;
    }

    public void setTicket(String ticket) {
        this.ticket = ticket;
    }


    @Override
    public String toString() {
        return "QrCode{" +
                "id='" + id + '\'' +
                ", nikeName='" + nikeName + '\'' +
                ", headImg='" + headImg + '\'' +
                ", accountId='" + accountId + '\'' +
                ", label='" + label + '\'' +
                ", type=" + type +
                ", totalNum=" + totalNum +
                ", newNum=" + newNum +
                ", followNum=" + followNum +
                ", url='" + url + '\'' +
                ", ticket='" + ticket + '\'' +
                ", pushType=" + pushType +
                ", materialIds='" + materialIds + '\'' +
                ", articlesIds='" + articlesIds + '\'' +
                ", createTime='" + createTime + '\'' +
                ", expireTime='" + expireTime + '\'' +
                ", contents=" + contents +
                '}';
    }
}
