package com.idiot.operationbackend.support;

import java.math.BigDecimal;
import java.net.URLDecoder;
import java.time.*;
import java.time.format.DateTimeFormatter;
import java.util.Locale;

/**
 * @author wang xiao
 * @date Created in 11:52 2020/9/11
 */
public class Constants {

    public static final String SUCCESS = "success";

    public static final Locale DEFAULT_LOCALE = Locale.CHINA;

    public static final ZoneOffset DEFAULT_ZONE= ZoneOffset.of("+8");

    public static final DateTimeFormatter DATE_TIME_FORMATTER = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss",DEFAULT_LOCALE);

    public static final DateTimeFormatter DATE_TIME_FORMATTER1 = DateTimeFormatter.ofPattern("yyyy-MM-dd HH",DEFAULT_LOCALE);

    public static final DateTimeFormatter DATE_FORMATTER = DateTimeFormatter.ofPattern("yyyy-MM-dd",DEFAULT_LOCALE);

    public static final String DEFAULT_HEAD_IMG = "http://pic.51yuansu.com/pic3/cover/01/69/80/595f67c2aff1e_610.jpg";

    /**
     * 第三方 ticket
     */
    public static final String COMPONENT_VERIFY_TICKET ="COMPONENT_VERIFY_TICKET_%s";
    /**
     * 第三方 ACCESS_TOKEN
     */
    public static final String COMPONENT_ACCESS_TOKEN = "COMPONENT_ACCESS_TOKEN_%s";
    /**
     * 授权方 ACCESS_TOKEN
     */
    public static final String AUTHORIZER_ACCESS_TOKEN = "AUTHORIZER_ACCESS_TOKEN_%s";

    /**
     * 同步用户锁
     */
    public static final String LOCK_SYNC_USER = "LOCK_SYNC_USER_%s";

    public static final String LOCK_SYNC_TAG = "LOCK_SYNC_TAG_%s";

    public static final LocalTime DEFAULT_TIME = LocalTime.of(0,0,0);

    public static final BigDecimal ZERO_RATE = BigDecimal.valueOf(0.00);

    /**
     * 粉丝动作 0-粉丝消息,1-新关注,2-关注,3-取关,4-扫描二维码,5-菜单点击
     */
    public static final int NEW = 1;

    public static final int MSG = 0;

    public static final int SUBSCRIBE = 2;

    public static final int CANCEL = 3;

    public static final int SCAN = 4;

    public static final int MENU = 5;


    public static final long IMAGE_MAX_SIZE = 1024*1024*10;
    public static final long VOICE_MAX_SIZE = 1024*1024*2;
    public static final long VIDEO_MAX_SIZE = 1024*1024*10;
    public static final long THUMB_MAX_SIZE = 64*1024;

    public static final String IMAGE_SUPPORTED= "bmp,png,jpeg,jpg,gif";
    public static final String VOICE_SUPPORTED= "mp3,wma,wav,amr";
    public static final String VIDEO_SUPPORTED= "mp4";
    public static final String THUMB_SUPPORTED= "JPG";


    public static final String IMAGE = "image";

    public static final String VOICE = "voice";

    public static final String VIDEO = "video";

    public static final String THUMB = "thumb";

    /**
     *  计算 比率
     * @author wangxiao
     * @date 10:58 2020/9/17
     * @param now
     * @param before
     * @return java.math.BigDecimal
     */
    public static BigDecimal calcRate(long now, long before) {
        if (0 == before) {
            return BigDecimal.valueOf((now*100.0)/1.0);
        } else if (0 == now) {
            return Constants.ZERO_RATE;
        }else {
            return BigDecimal.valueOf(((now - before) * 100) / before).setScale(2);
        }
    }

    // 以下三个方法 感觉是多余 但是懒得删除 --- start
    /**
     *  时间格式是yyyy-mm-dd
     * @author wangxiao
     * @date 10:45 2020/9/17
     * @param dateStr
     * @return java.time.LocalDateTime
     */
    public static LocalDateTime toLocalDateTime (String dateStr) {
        return LocalDate.parse(dateStr,Constants.DATE_FORMATTER).atTime(0,0,0);
    }

    /**
     *  描述转时间（多余）
     * @author wangxiao
     * @date 10:57 2020/9/17
     * @param epochSecond
     * @return java.time.LocalDateTime
     */
    public static LocalDateTime toLocalDateTime (long epochSecond ) {
        return LocalDateTime.ofInstant(Instant.ofEpochSecond(epochSecond),Constants.DEFAULT_ZONE);

    }

    /**
     *  时间转秒数（多余）
     * @author wangxiao
     * @date 10:57 2020/9/17
     * @param dateTime
     * @return java.time.LocalDateTime
     */
    public static long toEpochSecond (LocalDateTime dateTime) {
        return dateTime.toEpochSecond(Constants.DEFAULT_ZONE);
    }
    // 以上三个方法 感觉是多余 但是懒得删除 --- end




}
